"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ChildProcessMongoshBus = void 0;
const rpc_1 = require("./rpc");
class ChildProcessMongoshBus {
    constructor(eventEmitter, childProcess) {
        const exposedEmitter = (0, rpc_1.exposeAll)({
            emit(...args) {
                eventEmitter.emit(...args);
            },
            on() {
                throw new Error("Can't use `on` method on ChildProcessMongoshBus");
            },
            once() {
                throw new Error("Can't use `once` method on ChildProcessMongoshBus");
            }
        }, childProcess);
        this.exposedEmitter = exposedEmitter;
    }
    terminate() {
        this.exposedEmitter[rpc_1.close]();
    }
}
exports.ChildProcessMongoshBus = ChildProcessMongoshBus;
//# sourceMappingURL=child-process-mongosh-bus.js.map